This directory contains the Authentication Module of the project. It is created in the aim of achieving the following:

* retrieve the CSPRNG value from the database to generate the payload
* create an algorithm to inject the payload every time the user tries to authenticate using his fingerprint
* create the reverse algorithm of the payload injection process to retrieve the payload
* create an algorithm to compare the two payloads
* create a scorer to generate a matching score of the two compared payloads
* create a decision module that compares the generated score with the threshold score to authenticate only the legitimate user

The coding will be done in Jupyter Notebook using Python.