# Import Libraries

import os
import binascii
import cv2
import string
import math
from difflib import SequenceMatcher
from getpass import getpass



# Random Number Generation

def randomNumberGeneration():
    csprngVal = int(binascii.hexlify(os.urandom(12)), 16)
    return csprngVal



# Payload Generation

def payloadGeneration(csprngVal, incomingHexVal):
    decimalHexVal = int(incomingHexVal, 16)
    print("Hexadecimal value converted to decimal: ", decimalHexVal) # Line not needed in the integrated system
    payloadInt = csprngVal + decimalHexVal
    payload = str(payloadInt)
    return payload



# Payload Injection and Retrieval

def steg(passphrase, template, payload):
    #===================== PAYLOAD INJECTION STARTS FROM HERE =====================
    d={}
    c={}

    for i in range(255):
        d[chr(i)]=i
        c[i]=chr(i)


    #print(c)

    x=cv2.imread(template)

    i=x.shape[0]
    j=x.shape[1]
    print(i,j)

    key = passphrase
    text = payload

    kl=0
    tln=len(text)
    z=0 #decides plane
    n=0 #number of row
    m=0 #number of column

    l=len(text)

    for i in range(l):
        x[n,m,z]=d[text[i]]^d[key[kl]]
        n=n+1
        m=m+1
        m=(m+1)%3
        kl=(kl+1)%len(key)

    cv2.imwrite("encrypted_img.jpg",x) 
    os.startfile("encrypted_img.jpg")
    print("Data Hiding in Image completed successfully.")
    #x=cv2.imread(“encrypted_img.jpg")

    #===================== PAYLOAD RETRIEVAL STARTS FROM HERE =====================
    kl=0
    tln=len(text)
    z=0 #decides plane
    n=0 #number of row
    m=0 #number of column

    key1 = passphrase
    decrypt = ""

    if key == key1 :
        for i in range(l):
            decrypt+=c[x[n,m,z]^d[key[kl]]]
            n=n+1
            m=m+1
            m=(m+1)%3
            kl=(kl+1)%len(key)
            
        return decrypt



# Similarity Scorer

def similarityScorer(refPayload, checkPayload):
    return SequenceMatcher(None, refPayload, checkPayload).ratio()



# Authentication

def authenticate(checkPayload, refPayload):
    thresholdScore = 0.889999
    similarityScore = similarityScorer(refPayload, checkPayload)
    
    if similarityScore >= thresholdScore:
        print("Authentication Successful!")
    
    else:
        print("Unsuccessful Authentication!")



# Obtain Passphrase

def getPassphrase():
    passphrase1 = getpass(prompt = 'Please enter a one-time passphrase of your choice: ')
    passphrase2 = getpass(prompt = 'Re-enter the one-time passphrase: ')
    
    if passphrase1 == passphrase2:
        pass
        
    else:
        print("Error! Mismatching passphrases.")
        passphrase1 == passphrase2 == ''
        passphrase()
    
    return passphrase1